#include <Practicum.h>

extern "C" {
#include "usbdrv.h"
}

#define RQ_GET_X       0
#define RQ_GET_Y       1
#define RQ_GET_SWITCH  2

//////////////////////////////////////////////////////////////////////
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  usbRequest_t *rq = (usbRequest_t*)data;
  static uint8_t switch_state;  /* must stay when usbFunctionSetup returns */
  static uint16_t x ;
  static uint16_t y ;

  if (rq->bRequest == RQ_GET_X)
  {
    x = analogRead(PC0) ;
    usbMsgPtr = (uint8_t*) &x ;
    return sizeof(x) ;  
  }

  else if ( rq->bRequest == RQ_GET_Y )
  {
    y = analogRead(PC1) ;
    usbMsgPtr = (uint8_t*) &y ;
    return sizeof(y);    
  }
 
  else if (rq->bRequest == RQ_GET_SWITCH)
  {
    if (digitalRead(PIN_PC2) == LOW) /* switch is pressed */ 
      switch_state = 1;
    else
      switch_state = 0;

    /* point usbMsgPtr to the data to be returned to host */
    usbMsgPtr = (uint8_t*) &switch_state;

    /* return the number of bytes of data to be returned to host */
    return sizeof(switch_state);
  }   
  return 0;   /* nothing to do; return no data back to host */
}

//////////////////////////////////////////////////////////////////////
void setup()
{
    pinMode(PIN_PC0, INPUT);
    pinMode(PIN_PC1, INPUT);
    pinMode(PIN_PC2, INPUT_PULLUP);
    pinMode(PIN_PD3, OUTPUT);

    usbInit();

    /* enforce re-enumeration of USB devices */
    usbDeviceDisconnect();
    delay(300);
    usbDeviceConnect();
}

//////////////////////////////////////////////////////////////////////
void loop()
{
  usbPoll();
}
